pipeline{
    environment {
        artifactId = " "
        pgkVersion = " "

        def mysqlPort = sh (
            script: "awk -v min=64000 -v max=65000 'BEGIN{srand(); print int(min+rand()*(max-min+1))}'",
            returnStdout: true
        ).trim()

        MYSQL_PORT = "$mysqlPort"
        MYSQL_HOST = "localhost"

    }
    agent any
    stages{
        stage("Clean"){
            steps{
                script {
                    
                    artifactId = sh (returnStdout: true, script: "grep '<artifactId>' pom.xml | head -n1 | cut -d'>' -f2 | cut -d'<' -f1").trim()
                    pgkVersion = sh (returnStdout: true, script: " grep '<version>' pom.xml | head -n1 | cut -d'>' -f2 | cut -d'<' -f1").trim()
                   
                }
                updateGitlabCommitStatus name: "build", state: "running"
                sh "chmod a+x mvnw"
                sh "./mvnw clean"
            }
        }
        stage("Test"){
            steps{
                
                script {
                    
                    docker.image('mysql:5').withRun("-e 'MYSQL_ROOT_PASSWORD=pass123' -e 'MYSQL_DATABASE=investimentos' -p $mysqlPort:3306") {
                        sh "while ! mysqladmin ping -P $mysqlPort -h0.0.0.0 --silent; do sleep 1; done"
                        sh "./mvnw test"
                    }
                }

                // sh 'echo skippesd'
            }
        }
        stage("Package"){
            steps{
                sh './mvnw package -DskipTests'
            }
        }
        stage("Deploy"){
            steps{
                script {
                    app = docker.build("registry-itau.mastertech.com.br/kaique-apiinvest")
                    withCredentials([usernamePassword(
                        credentialsId: 'registry_credential',
                        passwordVariable: 'PASSWORD',usernameVariable: 'USERNAME')]) {
                            sh "docker login -p $PASSWORD -u $USERNAME registry-itau.mastertech.com.br"
                        }
                    docker.withRegistry('https://registry-itau.mastertech.com.br', 'registry_credential') {
                        app.push("${env.BUILD_NUMBER}")
                        app.push('latest')
                    }
                }

                sh 'scp ./docker-compose.yml ubuntu@18.191.99.165:/home/ubuntu/api-investimentos'
                
                // sh "docker ps"
                // sh "docker build -t registry-itau.mastertech.com.br/kaique-apiinvest ."
                // sh "docker push registry-itau.mastertech.com.br/kaique-apiinvest"
                // sh "mv /var/lib/jenkins/workspace/kaique-base-pipeline_master/target/${artifactId}-${pgkVersion}.jar ./${artifactId}.jar"
                // sh "pwd"
                // sh "ls -la"
                // sh "scp ./${artifactId}.jar ubuntu@18.188.128.29:/home/ubuntu/apps"
            }
        }

        stage("Start Application"){
            steps{
                sh 'ssh -t ubuntu@18.191.99.165 docker-compose -f /home/ubuntu/api-investimentos/docker-compose.yml pull kaique-investimentos'
                sh 'ssh -t ubuntu@18.191.99.165 docker-compose -f /home/ubuntu/api-investimentos/docker-compose.yml up --no-deps -d kaique-investimentos'
                // sh "ssh -t ubuntu@18.191.99.165 docker ps -a"
                // sh "ssh -t ubuntu@18.188.128.29 cp /home/ubuntu/apps/${artifactId}-${pgkVersion}.jar /home/ubuntu/apps/${artifactId}.jar"
                // sh "ssh -t ubuntu@18.188.128.29 mv /home/ubuntu/apps/${artifactId}-${pgkVersion}.jar /home/ubuntu/apps/versioned/${artifactId}-${pgkVersion}.jar"
                // sh "ssh -t ubuntu@18.188.128.29 sudo systemctl restart api-invest "
            }
        }
    }
    options {
        gitLabConnection("gitlab")
    }
    post{
        always{
            cleanWs()
        }
        success{
            updateGitlabCommitStatus name: "build", state: "success"
        }
        failure{
            updateGitlabCommitStatus name: "build", state: "failed"
        }
    }
}
